/*
 * Keys.c
 *
 * Created: 10.04.2014 21:31:41
 *  Author: DL8NCI
 */ 


#include "Keys.h"
#include "I2C.h"
#include "Hardware.h"
#include "helpers.h"
#include <avr/io.h>

uint8_t key_null;

// sometimes we have nothing to do
void idle(void) { asm("nop" "\n\t"	::); }

void on_key_null_release(void) {
	if (cmode==0) {
		cmode = 1;
		ZERO_LED_LOW	// LED on
		}
	else if (cmode==3) {
		cmode = 2;
		ZERO_LED_HIGH	// LED off
		}
	}

void on_key_null_press(void) {
	}


void poll(void) {
	uint8_t h;
	if (AUX2_INT_TEST) return;
	h = ZERO_KEY_TEST;
//	h = PINA & 0x80;
	
	if ((h!=0) && (key_null < 4)) {
		I2C_sbi(TWI_AUX_2,4);
		key_null++;
		if (key_null==4) on_key_null_release();
		}
	else if ((h==0) && (key_null > 0)) {
		I2C_cbi(TWI_AUX_2,4);
		key_null--;
		if (key_null==0) on_key_null_press();
		}
	}

void Keys_init(void) {
	
	ZERO_LED_HIGH
	
	ZERO_KEY_DIR_IN
	ZERO_KEY_HIGH
	
	AUX2_INT_HIGH
	
	key_null = 4;
	}

