/*
 * Mega32Aux.h
 *
 * Created: 04.05.2014 21:06:49
 *  Author: DL8NCI
 */ 


#ifndef __MEGA32AUX
#define __MEGA32AUX __MEGA32AUX

#define FOC0_bm				1 << FOC0

#define WGM0_normal_bm		0 << WGM01 | 0 << WGM00
#define WGM0_PWM_bm			0 << WGM01 | 1 << WGM00
#define WGM0_CTC_bm			1 << WGM01 | 0 << WGM00
#define WGM0_fast_PWM_bm	1 << WGM01 | 1 << WGM00

#define COM0_normal_bm			0 << COM01 | 0 << COM00
#define COM0_non_PWM_toggle_bm	0 << COM01 | 1 << COM00
#define COM0_non_PWM_clear_bm	1 << COM01 | 0 << COM00
#define COM0_non_PWM_set_bm		1 << COM01 | 1 << COM00

#define CS0_no_clock_bm			0 << CS02 | 0 << CS01 | 0 << CS00
#define CS0_div_1_bm			0 << CS02 | 0 << CS01 | 1 << CS00
#define CS0_div_8_bm			0 << CS02 | 1 << CS01 | 0 << CS00
#define CS0_div_64_bm			0 << CS02 | 1 << CS01 | 1 << CS00
#define CS0_div_256_bm			1 << CS02 | 0 << CS01 | 0 << CS00
#define CS0_div_1024_bm			1 << CS02 | 0 << CS01 | 1 << CS00
#define CS0_T0_falling_bm		1 << CS02 | 1 << CS01 | 0 << CS00
#define CS0_T0_rising_bm		1 << CS02 | 1 << CS01 | 1 << CS00




#define FOC2_bm				1 << FOC2

#define WGM2_normal_bm		0 << WGM21 | 0 << WGM20
#define WGM2_PWM_bm			0 << WGM21 | 1 << WGM20
#define WGM2_CTC_bm			1 << WGM21 | 0 << WGM20
#define WGM2_fast_PWM_bm	1 << WGM21 | 1 << WGM20

#define COM2_normal_bm			0 << COM21 | 0 << COM20
#define COM2_non_PWM_toggle_bm	0 << COM21 | 1 << COM20
#define COM2_non_PWM_clear_bm	1 << COM21 | 0 << COM20
#define COM2_non_PWM_set_bm		1 << COM21 | 1 << COM20

#define CS2_no_clock_bm			0 << CS22 | 0 << CS21 | 0 << CS20
#define CS2_div_1_bm			0 << CS22 | 0 << CS21 | 1 << CS20
#define CS2_div_8_bm			0 << CS22 | 1 << CS21 | 0 << CS20
#define CS2_div_32_bm			0 << CS22 | 1 << CS21 | 1 << CS20
#define CS2_div_64_bm			1 << CS22 | 0 << CS21 | 0 << CS20
#define CS2_div_128_bm			1 << CS22 | 0 << CS21 | 1 << CS20
#define CS2_div_256_bm			1 << CS22 | 1 << CS21 | 0 << CS20
#define CS2_div_1024_bm			1 << CS22 | 1 << CS21 | 1 << CS20



#define COM1A_normal_bm				0 << COM1A1 | 0 << COM1A0
#define COM1A_non_PWM_toggle_bm		0 << COM1A1 | 1 << COM1A0
#define COM1A_non_PWM_clear_bm		1 << COM1A1 | 0 << COM1A0
#define COM1A_non_PWM_set_bm		1 << COM1A1 | 1 << COM1A0

#define COM1B_normal_bm				0 << COM1B1 | 0 << COM1B0
#define COM1B_non_PWM_toggle_bm		0 << COM1B1 | 1 << COM1B0
#define COM1B_non_PWM_clear_bm		1 << COM1B1 | 0 << COM1B0
#define COM1B_non_PWM_set_bm		1 << COM1B1 | 1 << COM1B0

#define FOC1A_bm					1 << FOC1A
#define FOC1B_bm					1 << FOC1B

#define WGM1_A_normal_bm			0 << WGM11 | 0 << WGM10
#define WGM1_A_CTC_bm				0 << WGM11 | 0 << WGM10

#define WGM1_B_normal_bm			0 << WGM13 | 0 << WGM12
#define WGM1_B_CTC_bm				0 << WGM13 | 1 << WGM12

#define ICNC1_bm					1 << ICNC1
#define ICES1_bm					1 << ICES1

#define CS1_no_clock_bm				0 << CS12 | 0 << CS11 | 0 << CS10
#define CS1_div_1_bm				0 << CS12 | 0 << CS11 | 1 << CS10
#define CS1_div_8_bm				0 << CS12 | 1 << CS11 | 0 << CS10
#define CS1_div_64_bm				0 << CS12 | 1 << CS11 | 1 << CS10
#define CS1_div_256_bm				1 << CS12 | 0 << CS11 | 0 << CS10
#define CS1_div_1024_bm				1 << CS12 | 0 << CS11 | 1 << CS10
#define CS1_T1_falling_bm			1 << CS12 | 1 << CS11 | 0 << CS10
#define CS1_T1_rising_bm			1 << CS12 | 1 << CS11 | 1 << CS10


#define ISC0_on_low_bm				0 << ISC01 | 0 << ISC00
#define ISC0_on_change_bm			0 << ISC01 | 1 << ISC00
#define ISC0_on_fall_bm				1 << ISC01 | 0 << ISC00
#define ISC0_on_rise_bm				1 << ISC01 | 1 << ISC00


#define ISC1_on_low_bm				0 << ISC11 | 0 << ISC10
#define ISC1_on_change_bm			0 << ISC11 | 1 << ISC10
#define ISC1_on_fall_bm				1 << ISC11 | 0 << ISC10
#define ISC1_on_rise_bm				1 << ISC11 | 1 << ISC10

#define INT0_bm						1 << INT0
#define INT1_bm						1 << INT1
#define INT2_bm						1 << INT2

#define INTF0_bm					1 << INTF0
#define INTF1_bm					1 << INTF1
#define INTF2_bm					1 << INTF2



#endif